//Ejercicio 6.8 del Texto guía
//Algoritmos y Estructuras de Datos II: Algoritmos
//Domingo Giménez, Joaquín Cervera, Ginés García y Norberto Marín
//Diego Marín editor, 2003

//Se muestra el tiempo de ejecución
//y compilando con -D CONTAR también el número de operaciones
//
//la entrada es un número con el tamaño de la matriz

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <signal.h>

void inicializar(int *x,int t)
//todos los casos son iguales, por lo que se generan los datos aleatoriamente
{
  int i,j;

  for(i=0;i<t;i++)
  {  
     for(j=0;j<t;j++)
     {
         x[i*t+j] =(int)(((1.*rand())/RAND_MAX)*(200000)-100000);
     }
  }
}

long long mseconds(){
  struct timeval t;
  gettimeofday(&t, NULL);
  return t.tv_sec*1000000 + t.tv_usec;
}

double ejer6_8(int *x,int n)
{
    int p,cont=0;
    int i,j;
    double operaciones=0;

    p=0;
#ifdef CONTAR
    operaciones++;
#endif
    for(i=0;i<n;i++)
    {
#ifdef CONTAR
    operaciones++;
#endif
        p=p+i*i;
#ifdef CONTAR
    operaciones++;
#endif
        for(j=0;j<p;j++)
        {
#ifdef CONTAR
    operaciones++;
#endif
            cont++;
#ifdef CONTAR
    operaciones++;
#endif
        }
#ifdef CONTAR
    operaciones++;
#endif
    }
#ifdef CONTAR
    operaciones++;
#endif
    return operaciones;
}

void escribirtab(long long x)
{
   long long billones,milmillones,millones,miles,unidades;

   billones=x/1000/1000/1000/1000;
   x=(x-billones*1000*1000*1000*1000);
   milmillones=x/1000/1000/1000;
   x=x-milmillones*1000*1000*1000;
   millones=x/1000/1000;
   x=x-millones*1000*1000;
   miles=x/1000;
   unidades=x-miles*1000;

   printf("%Ld %03Ld %03Ld , %03Ld %03Ld ",billones,milmillones,millones,miles,unidades);
}

void escribir(long long t,long long o)
{
    printf("Tiempo: ");
    escribirtab(t);
    printf(" segundos");
#ifdef CONTAR
    printf("; Operaciones: ");
    escribirtab(o);
    printf("millones");
#endif
    printf("\n");
}

int main() {
    int *x;   
    int n;
    double operaciones;

    long long ti,tf;

    scanf("%d",&n);

    x=(int *) malloc(sizeof(int)*n*n);
   
    inicializar(x,n);
   
    ti=mseconds(); 
    operaciones=ejer6_8(x,n);
    tf=mseconds();
    
     escribir(tf-ti,(long long) operaciones);

    free(x);
}
  
