//Ejercicio 6.7 del Texto guía
//Algoritmos y Estructuras de Datos II: Algoritmos
//Domingo Giménez, Joaquín Cervera, Ginés García y Norberto Marín
//Diego Marín editor, 2003

//Se muestra el tiempo de ejecución
//y compilando con -D CONTAR también el número de operaciones
//
//Pueden generarse entradas del caso más favorable, más desfavorable y promedio
//
//la entrada son un carácter (m para más favorable, M para más desfavorable y p para promedio)
//y un número que representa el tamano del array

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <signal.h>

void inicializar_m(int *x,int t)
//inicializacion de datos en el caso más favorable
//valores del array ordenados
{
  int i;

  for(i=0;i<t;i++)
  {  
     x[i] =i;
  }
}

void inicializar_M(int *x,int t)
//inicializacion de datos en el caso más desfavorable
//valores del array inversamente ordenados
{
  int i;

  for(i=0;i<t;i++)
  {  
     x[i] =t-i;
  }
}

void inicializar_p(int *x,int t)
//inicializacion de datos en el caso mas favorable
//valores de x aleatorios
{
  int i;

  for(i=0;i<t;i++)
  {  
     x[i] =(int)(((1.*rand())/RAND_MAX)*(200000)-100000);
  }
}

long long mseconds(){
  struct timeval t;
  gettimeofday(&t, NULL);
  return t.tv_sec*1000000 + t.tv_usec;
}

double ejer6_7(int *x,int n)
{
    int cont;
    int i,j;
    double operaciones=0;

    cont=0;
#ifdef CONTAR
    operaciones++;
#endif
    for(i=0;i<n;i++)
    {
#ifdef CONTAR
    operaciones++;
#endif
        for(j=0;j<i-1;j++)
        {
#ifdef CONTAR
    operaciones++;
#endif
            if(x[i]<x[j])
            {
                cont++;
#ifdef CONTAR
    operaciones++;
#endif
            }
#ifdef CONTAR
    operaciones++;
#endif
        }
#ifdef CONTAR
    operaciones++;
#endif
    }
#ifdef CONTAR
    operaciones++;
#endif
    return operaciones;
}

void escribirtab(long long x)
{
   long long billones,milmillones,millones,miles,unidades;

   billones=x/1000/1000/1000/1000;
   x=(x-billones*1000*1000*1000*1000);
   milmillones=x/1000/1000/1000;
   x=x-milmillones*1000*1000*1000;
   millones=x/1000/1000;
   x=x-millones*1000*1000;
   miles=x/1000;
   unidades=x-miles*1000;

   printf("%Ld %03Ld %03Ld , %03Ld %03Ld ",billones,milmillones,millones,miles,unidades);
}

void escribir(long long t,long long o)
{
    printf("Tiempo: ");
    escribirtab(t);
    printf(" segundos");
#ifdef CONTAR
    printf("; Operaciones: ");
    escribirtab(o);
    printf("millones");
#endif
    printf("\n");
}

int main() {
    int *x;   
    int n;
    char tipo;
    double operaciones;

    long long ti,tf;

    scanf("%c",&tipo);
    scanf("%d",&n);

    x=(int *) malloc(sizeof(int)*n);
   
    if(tipo=='m')
    {
        inicializar_m(x,n);
    }
    if(tipo=='M')
    {
        inicializar_M(x,n);
    }
    if(tipo=='p')
    {
        inicializar_p(x,n);
    }
    ti=mseconds(); 
    operaciones=ejer6_7(x,n);
    tf=mseconds();
    
    escribir(tf-ti,(long long) operaciones);

    free(x);
}
  
